<?php
declare(strict_types=1);

namespace Catequil\ORM\Filter;

use Doctrine\ORM\EntityManagerInterface;
use Laminas\Filter\FilterInterface;
use Laminas\ServiceManager\Factory\FactoryInterface;
use Psr\Container\ContainerExceptionInterface;
use Psr\Container\ContainerInterface;
use Psr\Container\NotFoundExceptionInterface;

/**
 * Class EntityFilterFactory
 *
 * @package Catequil\ORM\Filter
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/catequil-orm
 */
final class EntityFilterFactory implements FactoryInterface
{
    /**
     * @param ContainerInterface $container
     * @param $requestedName
     * @param array|null $options
     *
     * @return FilterInterface
     *
     * @throws ContainerExceptionInterface
     * @throws NotFoundExceptionInterface
     */
    public function __invoke(ContainerInterface $container, $requestedName, ?array $options = null): FilterInterface
    {
        return new EntityFilter(
            $container->get(EntityManagerInterface::class),
            $options
        );
    }
}
