<?php
declare(strict_types=1);

namespace CatequilTest\ORM\Container;

use Ak\Test\AbstractTestCase;
use Catequil\ORM\ConfigProvider;
use Catequil\ORM\Container\EntityManagerFactory;
use Doctrine\ORM\EntityManager;
use Doctrine\ORM\EntityManagerInterface;
use Psr\Container\ContainerExceptionInterface;
use Psr\Container\NotFoundExceptionInterface;

/**
 * Class EntityManagerFactoryTest
 *
 * @package CatequilTest\ORM\Container
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/catequil-orm
 */
final class EntityManagerFactoryTest extends AbstractTestCase
{
    protected array $providers = [
        \Catequil\Db\ConfigProvider::class,
        ConfigProvider::class,
    ];

    /**
     * @return void
     *
     * @throws ContainerExceptionInterface
     * @throws NotFoundExceptionInterface
     */
    public function testCanCreateTheManager(): void
    {
        $container = $this->getContainer([
            'development' => true,
        ]);
        $factory = new EntityManagerFactory();

        /** @var EntityManager $em */
        $em = $factory($container, '');

        self::assertInstanceOf(EntityManagerInterface::class, $em);
    }
}
